public class TestIntern {

  private static final String s1 = "coucou";
  private static final String s2 = f() + f();
  private static String f() { return "cou"; }

  public static void main (String[] args) {
    // The strings [s1] and [s2] are structurally equal,
    // that is, they have the same characters:
    assert (s1.equals(s2));
    // However, they are distinct objects, that is, they
    // are two distinct heap blocks:
    assert (s1 != s2);
    // Create an intern.
    IIntern i = new Intern ();
    // The string [i.intern(s1)] is structurally equal to [s1].
    assert (i.intern(s1).equals(s1));
    // Same for [s2].
    assert (i.intern(s2).equals(s2));
    // And the strings [i.intern(s1)] and [i.intern(s2)] are
    // physically equal, that is, they are the same heap block.
    assert (i.intern(s1) == i.intern(s2));
    // Success.
    System.out.println("OK");
  }

}
